----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:35:53 04/10/2012 
-- Design Name: 
-- Module Name:    pulsetrain - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pulsetrain is
    Port ( clk : in  STD_LOGIC;
           ce : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           q : out  STD_LOGIC_VECTOR (7 downto 0));
end pulsetrain;

architecture Behavioral of pulsetrain is

	COMPONENT pulse
	PORT( clk	:	IN	STD_LOGIC; 
          ce	:	IN	STD_LOGIC; 
          rst	:	IN	STD_LOGIC; 
          q	:	OUT	STD_LOGIC);
	END COMPONENT;

	COMPONENT func2
	PORT(
		clk : IN std_logic;
		ce : IN std_logic;
		rst : IN std_logic;          
		q : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	signal shifterQ: STD_LOGIC_VECTOR (7 downto 0);
	signal tmp: STD_LOGIC_VECTOR (7 downto 0);

begin
	process(clk, ce)
	begin
		if (clk'event and clk='1') then
			if (ce = '1') then
				tmp <= shifterQ;
			else
				tmp <= x"00";
			end if;
		end if;
	end process;

	f1: func2 PORT MAP(
		clk => clk,
		ce => ce,
		rst => rst,
		q => shifterQ
	);

   p0: pulse PORT MAP(
		clk => clk, 
		ce => tmp(0), 
		rst => rst, 
		q => q(0)
   );
   
   p1: pulse PORT MAP(
		clk => clk, 
		ce => tmp(1), 
		rst => rst, 
		q => q(1)
   );
   
   p2: pulse PORT MAP(
		clk => clk, 
		ce => tmp(2), 
		rst => rst, 
		q => q(2)
   );
   
   p3: pulse PORT MAP(
		clk => clk, 
		ce => tmp(3), 
		rst => rst, 
		q => q(3)
   );
   
   p4: pulse PORT MAP(
		clk => clk, 
		ce => tmp(4), 
		rst => rst, 
		q => q(4)
   );
   
   p5: pulse PORT MAP(
		clk => clk, 
		ce => tmp(5), 
		rst => rst, 
		q => q(5)
   );
   
   p6: pulse PORT MAP(
		clk => clk, 
		ce => tmp(6), 
		rst => rst, 
		q => q(6)
   );
   
   p7: pulse PORT MAP(
		clk => clk, 
		ce => tmp(7), 
		rst => rst, 
		q => q(7)
   );
   

end Behavioral;

